﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=6.8
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim pnlFilterTools As Panel
	Dim scvFilter As ScrollView
	Dim NumberOfColumns=Main.colnumber As Int
	Dim btnFilterGo, btnFilterAND, btnFilterOR, btnFilterback As Button
	Dim SortDirection(NumberOfColumns) As String
	Dim ColumnName(NumberOfColumns)=Main.ColumnName As String	' names of the columns
	Dim Columntext(NumberOfColumns)=Main.Columntext As String	' tex of header
	Dim DBTableName= Main.tableview As String
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Color = Colors.Cyan
	Activity.Title = "فیلتر جدول"
	
	If Activity.Width < Activity.Height Then
		pnlFilterTools.Top =  Activity.Height - pnlFilterTools.Height
		scvFilter.Height = Activity.Height - pnlFilterTools.Height
	Else
		pnlFilterTools.Left = Activity.Width - pnlFilterTools.Width
		scvFilter.Height = Activity.Height
		scvFilter.Width = Activity.Width - pnlFilterTools.Width
	End If
	
	scvFilter.Panel.Height = (NumberOfColumns - 1) * mainview.THeight
	scvFilter.Panel.Color = Colors.RGB(0,0,128)
End Sub

Sub Activity_Resume
	Dim i, j As Int
	For i = 1 To NumberOfColumns - 1
		Dim l As Label
		Dim spn As Spinner
		l.Initialize("")
		scvFilter.Panel.AddView(l, 10dip, (i - 1) * mainview.THeight, scvFilter.Width - 20dip, mainview.LHeight)
		l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		l.Tag = i
		l.TextColor = Colors.Yellow
		l.Text = Columntext(l.Tag)
		spn.Initialize("spnFilter")
		scvFilter.Panel.AddView(spn, 5dip, (i - 1) * mainview.THeight + mainview.LHeight, scvFilter.Width - 10dip, mainview.EHeight)
		spn.Tag = i
		Dim Curs As Cursor
		Dim txt As String
		txt = "SELECT DISTINCT " & ColumnName(i) & " FROM " & DBTableName & " ORDER BY " & ColumnName(i) & " ASC"
		Curs = Main.SQL1.ExecQuery(txt)
		spn.Clear
		spn.Add("ALL")
	For j = 0 To Curs.RowCount - 1
			Curs.Position = j
			spn.Add(Curs.GetString(ColumnName(i)))
			Next
			spn.SelectedIndex = mainview.FilterCriteriaID.Get(i)
	Next
	' stes the column sort orientation to ASC 
	For i = 0 To NumberOfColumns - 1
				SortDirection(i) = "ASC"
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilterGo_Click
	mainview.Filtered = True
	mainview.SelectedRow = -1
	Activity.Finish
End Sub

Sub btnFilterAND_Click
	btnFilterOR.TextColor = Colors.Red
	mainview.FilterType = "AND"
	btnFilterAND.TextColor = Colors.RGB(0,255,0)
End Sub

Sub btnFilterOR_Click
	btnFilterAND.TextColor = Colors.Red
	mainview.FilterType = "OR"
	btnFilterOR.TextColor = Colors.RGB(0,255,0)
End Sub

Sub btnFilterClearAll_Click
	Dim i As Int
	Dim index As Int
	For i = 0 To NumberOfColumns - 2
		Dim spn As Spinner
		spn = scvFilter.Panel.GetView(i * 2 + 1)
		spn.SelectedIndex = 0
		index=i+1
		mainview.FilterCriteria.Set(index, "ALL")
		mainview.FilterCriteriaID.Set(index, 0)
	Next
	
End Sub

Sub spnFilter_ItemClick (Position As Int, Value As Object)
	Dim spn As Spinner
	
	spn = Sender
	mainview.FilterCriteria.Set(spn.Tag, Value)
	mainview.FilterCriteriaID.Set(spn.Tag, Position)
End Sub

Sub btnFilterback_Click
	Activity.Finish
End Sub