﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=6.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	'	تعریف انواع بارکد ها
	Dim qr As QRcode
	Dim ac As AztecCode
	Dim dm As DataMatrix
	Dim pdf As PDF417
	Dim c128 As Code128
	Dim ean_8 As EAN8
	Dim ean_13 As EAN13
	Dim c39 As Code39
	Dim itfc As ITF
	Dim cb As Codabar
	Dim bm As Bitmap
	Private ImageView1 As ImageView
	Private Spinner1 As Spinner
	Private EditText1 As EditText
	Dim par="qr" As String
	Dim FolderChooser As BSFileChooser
	Dim inputMethod As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	inputMethod.Initialize("")
	Activity.LoadLayout("generation")
	EditText1.Text="Parameters"
	Activity.Title=Main.qurytitle
	'	اطلاعات مربوط به انواع بارکد ها
	qr.Initialize()
	Spinner1.Add("qr")
	ac.Initialize()
	Spinner1.Add("ac")
	dm.Initialize()
	Spinner1.Add("dm")
	pdf.Initialize()
	Spinner1.Add("pdf")
	c128.Initialize()
	Spinner1.Add("c128")
	ean_8.Initialize()	'Pass only first 7 digits - the checksum will be calculated in class EAN8
	Spinner1.Add("ean_8")
	ean_13.Initialize()	'Pass only first 12 digits - the checksum will be calculated in class EAN13
	Spinner1.Add("ean_13")
	c39.Initialize()
	Spinner1.Add("c39")
	itfc.Initialize()	'Number of digits must be even and at least 6 digits long
	Spinner1.Add("itfc")
	cb.Initialize()
	Spinner1.Add("cb")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub genarate(model As String, parametr As String)
	Select model
		Case "qr"
			bm = qr.drawQRCode(parametr)
		Case "ac"
			bm = ac.drawAztecCode(parametr)
		Case "dm"
			bm = dm.drawDataMatrixCode(parametr)
		Case "pdf"
			bm = pdf.drawPDF417(parametr)
		Case "c128"
			bm = c128.drawCode128(parametr)
		Case "ean_8"
			If IsNumber(EditText1.Text) And	EditText1.Text.Length=7 Then	bm = ean_8.drawEAN8(parametr) Else ToastMessageShow("ورودی 7 رقم مجاز است",True)
		Case "ean_13"
			If IsNumber(EditText1.Text) And	EditText1.Text.Length=12 Then	bm = ean_13.drawEAN13(parametr) Else ToastMessageShow("ورودی 12 رقم مجاز است",True)
		Case "c39"
			bm = c39.drawCode39(parametr)
		Case "itfc"
			If IsNumber(EditText1.Text) And	EditText1.Text.Length>5 And EditText1.Text.Length Mod 2 = 0 Then bm = itfc.drawCodeITF(parametr) Else ToastMessageShow("تعداد ارقام ورودی زوج باشد و حداقل 6 رقم استفاده نمایید",False)
		Case "cb"
			bm = cb.drawCodabar(parametr)
	End Select
	ImageView1.SetBackgroundImage(bm)
	
End Sub

Sub ImageView1_Click
	
End Sub

Sub Button1_Click
	genarate(par,EditText1.Text)
End Sub

Sub Button2_Click
	If bm.IsInitialized Then
		Msgbox("محل مورد نظر به منظور ذخیره ی تصویر را انتخاب نمایید ","محل ذخیره بارکد")
		FolderChooser.ShowDirectoryPicker("dirPicker")
	Else
		ToastMessageShow("تصویر موجود نیست",False)
	End If
	
End Sub

Sub Spinner1_ItemClick (Position As Int, Value As Object)
	par=Value
	Select Value
		Case "qr"
			EditText1.InputType=EditText1.INPUT_TYPE_TEXT
		Case "ac"
			EditText1.InputType=EditText1.INPUT_TYPE_TEXT
		Case "dm"
			EditText1.InputType=EditText1.INPUT_TYPE_TEXT
			ToastMessageShow("فارسی مجاز نیست",False)
		Case "pdf"
			EditText1.InputType=EditText1.INPUT_TYPE_TEXT
			ToastMessageShow("این بارکد مختص رشته های طولانیت و در آن فارسی مجاز نیست",False)
		Case "c128"
			EditText1.InputType=EditText1.INPUT_TYPE_TEXT
			ToastMessageShow("فارسی مجاز نیست",False)
		Case "ean_8"
			EditText1.InputType=EditText1.INPUT_TYPE_NUMBERS
		Case "ean_13"
			EditText1.InputType=EditText1.INPUT_TYPE_NUMBERS
		Case "c39"
			inputMethod.SetCustomFilter(EditText1,EditText1.INPUT_TYPE_NUMBERS,"0123456789+-*%./ ")
		Case "itfc"
			EditText1.InputType=EditText1.INPUT_TYPE_NUMBERS
		Case "cb"
			inputMethod.SetCustomFilter(EditText1,EditText1.INPUT_TYPE_NUMBERS,"0123456789+-./")
	End Select
	genarate(par,EditText1.Text)
End Sub

Sub dirPicker_result(FilePath As String)
	Dim i=0 As Int
	Do While File.Exists(FilePath,"Barcode"&i&".png")
	i=i+1
	Loop
	Dim out As OutputStream
	out = File.OpenOutput(FilePath, "Barcode"&i&".png", False)
	bm.WriteToStream(out,100,"PNG")
	out.Close
	If File.Exists(FilePath,"Barcode"&i&".png") Then
		ToastMessageShow("Barcode"&i&".png"&"کپی شد",True)
		Activity.Finish
	Else
		ToastMessageShow("فایل کپی نشد",True)
	End If
End Sub

Sub back_Click
	Activity.Finish
End Sub